Bug 1305996 - Review Request: python-pyuv - A Python module which provides an interface to libuv
Review Request: python-pyuv - A Python module which provides an interface to...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: William Moreno
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2016-02-09 13:49 EST by Athmane Madjoudj
Modified: 2017-03-14 18:48 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-03-14 18:48:04 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
williamjmorenor: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Athmane Madjoudj 2016-02-09 13:49:22 EST
Spec URL: https://athmane.fedorapeople.org/pkgs/python-pyuv.spec
SRPM URL: https://athmane.fedorapeople.org/pkgs/python-pyuv-1.2.0-1.fc23.src.rpm
Description:

pyuv is a Python module which provides an interface to libuv.\
libuv is a high performance asynchronous networking and platform\
abstraction library.libuv is built on top of epoll/kequeue/event \
ports/etc on Unix and IOCP on Windows systems providing a consistent\
API on top of them.

Fedora Account System Username: athmane
Comment 1 Athmane Madjoudj 2016-02-09 13:53:39 EST
Rpmlint output:

python-pyuv.x86_64: W: spelling-error Summary(en_US) libuv -> Malibu
python-pyuv.x86_64: W: spelling-error %description -l en_US libuv -> Malibu
python-pyuv.x86_64: W: spelling-error %description -l en_US epoll -> poll, e poll
python-pyuv.x86_64: W: spelling-error %description -l en_US kequeue -> queue
python3-pyuv.x86_64: W: spelling-error Summary(en_US) libuv -> Malibu
python3-pyuv.x86_64: W: spelling-error %description -l en_US libuv -> Malibu
python3-pyuv.x86_64: W: spelling-error %description -l en_US epoll -> poll, e poll
python3-pyuv.x86_64: W: spelling-error %description -l en_US kequeue -> queue
python-pyuv.src: W: spelling-error Summary(en_US) libuv -> Malibu
python-pyuv.src: W: spelling-error %description -l en_US libuv -> Malibu
python-pyuv.src: W: spelling-error %description -l en_US epoll -> poll, e poll
python-pyuv.src: W: spelling-error %description -l en_US kequeue -> queue
Comment 2 Upstream Release Monitoring 2016-02-09 13:53:54 EST
athmane's scratch build of python-pyuv-1.2.0-1.fc23.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=12916998
Comment 3 Upstream Release Monitoring 2016-02-09 13:56:48 EST
athmane's scratch build of python-pyuv-1.2.0-1.fc23.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=12917017
Comment 4 Upstream Release Monitoring 2016-02-09 14:04:08 EST
athmane's scratch build of python-pyuv-1.2.0-1.fc23.src.rpm for f23 completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12917036
Comment 6 Athmane Madjoudj 2016-02-09 15:09:59 EST
New spec, the build did not include .py file (only .so):

Spec URL: https://athmane.fedorapeople.org/pkgs/python-pyuv.spec
SRPM URL: https://athmane.fedorapeople.org/pkgs/python-pyuv-1.2.0-3.fc23.src.rpm
Comment 7 Athmane Madjoudj 2016-02-09 17:42:34 EST
New build:

Spec URL: https://athmane.fedorapeople.org/pkgs/python-pyuv.spec
SRPM URL: https://athmane.fedorapeople.org/pkgs/python-pyuv-1.2.0-4.fc23.src.rpm


%changelog
* Tue Feb 09 2016 Athmane Madjoudj <athmanem@fedoraproject.org> 1.2.0-4
- Fix reqs since pyuv uses uv_tcp_init_ex (new in 1.7.0)
Comment 8 Upstream Release Monitoring 2016-02-09 17:52:22 EST
athmane's scratch build of python-pyuv-1.2.0-4.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12918404
Comment 9 William Moreno 2016-03-11 16:59:20 EST
I am not sure about this packaging, but need a lot of work.

You are not going to epel6 so you do not have this in the top of your spec:

%if 0%{?rhel} && 0%{?rhel} <= 6
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

So we have python3 in epel7:
http://mirror.us.leaseweb.net/epel/7/x86_64/p/python34-3.4.3-4.el7.x86_64.rpm

And if this is this library do not need nothing out of the python standar library you can build for python3 in epel7.

You are not providing a python2-subpackage.

You are not using the python-provides macro.

You have build requieres python-sphinx but you are no build any documentation in the spec, also do not provide a -doc subpackage.

You not requires but python3-sphinx and python-sphinx. 

Please look at this package spec:

http://pkgs.fedoraproject.org/cgit/rpms/python-pg8000.git/tree/python-pg8000.spec?h=master

It is up to date with current packaging guidelines and support both python3 and python2 in Fedora 24 and 25 and also Epel7, it will not compile in Fedora23 but you can test in koji to build in rawhide and epel7.

To get the source rpm in your F23 host just run:

rpmbuild -bs /home/user/rpmbuild/SPECS/python-pyuv.spec
Comment 10 William Moreno 2016-03-11 17:03:25 EST
Also note: if test try to download something this mean in most cases than you have missing BuildRequires and if those requires are not packaged yet you will need to package those requires too.

And in most cases a BuildRequires is a Requires too.
Comment 11 Athmane Madjoudj 2016-03-12 09:16:58 EST
Thanks for reviewing.

I started packaging pyuv before I was aware of the new Python guidelines. please find the updated SPEC and SRPM:

https://athmane.fedorapeople.org/pkgs/python-pyuv.spec

https://athmane.fedorapeople.org/pkgs/python-pyuv-1.2.0-5.fc23.src.rpm
Comment 12 William Moreno 2016-04-21 15:28:34 EDT
Package Review
==============

1.
[!]: Package contains no bundled libraries without FPC exception.
There is a complete libuv bundled in pyuv-1.2.0/deps/libuv/

2.
[!]: %check is present and all tests pass.
Most of the time with python packages try to get some pkgs from pypi in check there are missing build requires (and maybe missing requires) please doble check if dowloaded packages are already in Fedora repos, if so, include then as buildrequires, if not you must package then firt.

3.
There is a doc directory than you can compile to html with python-sphinx and include in a doc subpackage.

4.
Can these files go to a -devel supackage.
Unversioned so-files
--------------------
python2-pyuv: /usr/lib64/python2.7/site-packages/pyuv/_cpyuv.so
python3-pyuv: /usr/lib64/python3.4/site-packages/pyuv/_cpyuv.cpython-34m.so


===== MUST items =====
C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. 
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====
Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====
Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.

Rpmlint
-------
Checking: python2-pyuv-1.2.0-5.fc23.x86_64.rpm
          python3-pyuv-1.2.0-5.fc23.x86_64.rpm
          python-pyuv-debuginfo-1.2.0-5.fc23.x86_64.rpm
          python-pyuv-1.2.0-5.fc23.src.rpm
python-pyuv.src:59: W: macro-in-comment %{python2_version}
python-pyuv.src:60: W: macro-in-comment %{python3_version}
4 packages and 0 specfiles checked; 0 errors, 2 warnings.

Rpmlint (debuginfo)
-------------------
Checking: python-pyuv-debuginfo-1.2.0-5.fc23.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

Rpmlint (installed packages)
----------------------------
3 packages and 0 specfiles checked; 0 errors, 0 warnings.

Requires
--------
python-pyuv-debuginfo (rpmlib, GLIBC filtered):

python2-pyuv (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libpthread.so.0()(64bit)
    libpython2.7.so.1.0()(64bit)
    librt.so.1()(64bit)
    libuv.so.1()(64bit)
    python(abi)
    rtld(GNU_HASH)

python3-pyuv (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libpthread.so.0()(64bit)
    libpython3.4m.so.1.0()(64bit)
    librt.so.1()(64bit)
    libuv.so.1()(64bit)
    python(abi)
    rtld(GNU_HASH)

Provides
--------
python-pyuv-debuginfo:
    python-pyuv-debuginfo
    python-pyuv-debuginfo(x86-64)

python2-pyuv:
    python-pyuv
    python-pyuv(x86-64)
    python2-pyuv
    python2-pyuv(x86-64)

python3-pyuv:
    python3-pyuv
    python3-pyuv(x86-64)

Source checksums
----------------
https://pypi.python.org/packages/source/p/pyuv/pyuv-1.2.0.tar.gz :
  CHECKSUM(SHA256) this package     : d5783fbd21309e7c64f15ed9e73fd0aefbf9b71cf18fb328f5ca456c36e402e7
  CHECKSUM(SHA256) upstream package : d5783fbd21309e7c64f15ed9e73fd0aefbf9b71cf18fb328f5ca456c36e402e7
Comment 13 Athmane Madjoudj 2016-04-29 20:51:56 EDT
(In reply to William Moreno from comment #12)
> Package Review
> ==============
> 
> 1.
> [!]: Package contains no bundled libraries without FPC exception.
> There is a complete libuv bundled in pyuv-1.2.0/deps/libuv/
> 

Removed, it was not used during the build anyway (system-wide libuv forced before build steps)

> 2.
> [!]: %check is present and all tests pass.
> Most of the time with python packages try to get some pkgs from pypi in
> check there are missing build requires (and maybe missing requires) please
> doble check if dowloaded packages are already in Fedora repos, if so,
> include then as buildrequires, if not you must package then firt.
> 

Fixed

> 3.
> There is a doc directory than you can compile to html with python-sphinx and
> include in a doc subpackage.
> 

Fixed

> 4.
> Can these files go to a -devel supackage.
> Unversioned so-files
> --------------------
> python2-pyuv: /usr/lib64/python2.7/site-packages/pyuv/_cpyuv.so
> python3-pyuv: /usr/lib64/python3.4/site-packages/pyuv/_cpyuv.cpython-34m.so
> 

so-files are part of the module itself, if moved 'import pyuv' with fail.

Please find updated SPEC/SRPM:


SPEC: https://athmane.fedorapeople.org/pkgs/python-pyuv.spec
SRPM: https://athmane.fedorapeople.org/pkgs/python-pyuv-1.2.0-6.fc23.src.rpm
Comment 14 William Moreno 2016-06-01 17:04:54 EDT
Package aproved
Comment 15 Gwyn Ciesla 2016-06-10 10:03:42 EDT
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/python-pyuv
Comment 16 Fedora Update System 2016-06-10 17:24:30 EDT
python-pyuv-1.2.0-7.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-23e017fba4
Comment 17 Fedora Update System 2016-06-11 07:51:00 EDT
python-pyuv-1.2.0-7.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-23e017fba4
Comment 18 Fedora Update System 2017-03-14 18:48:04 EDT
python-pyuv-1.2.0-7.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.